//+------------------------------------------------------------------+
//|                                              EA_BB_StepMarti.mq4 |
//|                                     CopyLeft  2011, imuljawan.  |
//+------------------------------------------------------------------+
#property copyright "CopyLeft  2011, imuljawan"

//---- input parameters
extern int       band_period = 96;
extern double    band_dev = 2.0;
extern int       TakeProfit = 45;
extern int       StopLoss = 30;
extern int       magic = 12345;
extern double    pembagi_lot = 10000.0;
extern double    lot_multiplier = 1.67;
extern int       level_max = 9;
extern int       level_now = 0;
extern int       BatasMaxBB = 130;
extern int       BatasMinBB = 70;
extern int       PipsFromBB = 5;
extern double    BatasRangeBB_for_OP = 0.25;
extern bool      Reversal = false;
extern int       JmlHariUtkDailyRange = 5;
double TP, Step, DailyRange, Profit, target_tp, target_sl, last_lot, base_lot, order_profit;
int tipe, Slippage=3;
string stringtipe;
int tikets, spread;
double price, periksa_atas, periksa_bawah;
bool IdleStatus, baru=true;
string nn = "\n";
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   Comment("\n          BB EA",
        "\n +===================+",
        "\nCoding By imuljawan",
        "\nPersiapan dulu....");
      spread = MarketInfo(Symbol(),MODE_SPREAD);
      IdleStatus = FALSE;
      DailyRange = GetDailyAVG();
      base_lot = ND2(AccountBalance()/pembagi_lot);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{ 
   string komen;
   int i,e,u;
//----
   if(TimeDay(Time[0]) != TimeDay(Time[1])) DailyRange = GetDailyAVG(); // if ganti hari, ganti range BB
 
   if(!Available_Order()) {  // belum ada order untuk pair ini
      IdleStatus = FALSE;
      if(GetSignal() != -1) {  // Ada signal  BUY or SELL
         if(tikets != 0) {    // jika sudah pernah order, tiket yg lalu sudah ada nilainya.
            if(avail_order_in_history(tikets)) {
               if(order_profit > 0) level_now=0; 
               else if(order_profit < 0) { 
                  if(level_now==level_max) level_now=0; else level_now++;
               }
               if(level_now==0) base_lot = ND2(AccountBalance()/pembagi_lot);
            }
         }
         tipe = GetSignal();
         stringtipe = StrType(tipe);
         CreateOrder(tipe);
         IdleStatus = FALSE;
      }
   }
   
//----
   Profit = CheckOrderProfit();
   komen = komen + nn + "   Tgl = " + DoubleToStr(Day(),0) + "." + DoubleToStr(Month(),0) + "." + DoubleToStr(Year(),0);
   komen = komen + "      " + DoubleToStr(Hour(),0) + ":" + DoubleToStr(Minute(),0) + ":" + DoubleToStr(Seconds(),0) ;
   komen = komen + "    TP = " + DoubleToStr(target_tp,4) + "   Step = " + DoubleToStr(target_sl,4) + nn;
   komen = komen + "  Daily AVG = " + DoubleToStr(DailyRange,0);
   komen = komen + "  Min % BB Daily = " + DoubleToStr(BatasMinBB,0) + " = " + DoubleToStr(DailyRange * BatasMinBB / 100,0);
   komen = komen + " --- Max % Daily = " + DoubleToStr(BatasMaxBB,0) + " = " + DoubleToStr(DailyRange * BatasMaxBB / 100,0) + nn;
   komen = komen + "  Range BB = " + DoubleToStr(GetBB_Range(0),0);
   komen = komen + "  Profit = " + DoubleToStr(Profit,2) + nn;
   komen = komen + "  Balance = " + DoubleToStr(AccountBalance(),2);
   komen = komen + "  Equity = " + DoubleToStr(AccountEquity(),2) + nn;
   komen = komen + "  Tiket = " + DoubleToStr(tikets,0) + stringtipe + DoubleToStr(price,4) + nn;
   komen = komen + "  Last Lots = " + DoubleToStr(GetLot(),2) + "  Last Lvl = " + DoubleToStr(level_now,0) + nn;
   komen = komen + "  Idle Status = ";
   if(IdleStatus)  komen = komen + "TRUE" + nn; else komen = komen + "FALSE" + nn;
   Comment(komen);
   return(0);
  }
//+------------------------------------------------------------------+
bool avail_order_in_history(int tkt) {
bool ret;
//   Print("htiket:",tkt);
   for(int i=OrdersHistoryTotal()-1; i >= 0; i--) {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)) {
         if(OrderTicket()==tkt ) {
            order_profit = OrderProfit();
            Print("Order sudah close ",tkt," Ask:",Ask," bid:",Bid);
            ret = true;
            RefreshRates();
            break;
         }
      }
   }
return(ret);
}
double CheckOrderProfit() {
double ret;
   for(int i=OrdersTotal()-1; i>=0; i--) {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) 
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType() < 2) ret = ret + OrderProfit();
   }
return(ret);
}

void CreateOrder(int sign) {
   color warna;
   double tp, sl, lots;
   string komentar;
   lots = GetLot();
   target_sl = 0; target_tp = 0;
   if(sign == OP_BUY) { 
      warna = Blue; price = ND(MarketInfo(Symbol(),MODE_ASK));
      tp = ND(price + TakeProfit * Point);
      sl = ND(price - StopLoss * Point);
      komentar = "Buy at " + DoubleToStr(price,Digits);
   }
   if(sign == OP_SELL) {
      warna = Red; price = ND(MarketInfo(Symbol(),MODE_BID));
      tp = ND(price - TakeProfit * Point);
      sl = ND(price + StopLoss * Point);
      komentar = "Sell at " + DoubleToStr(price,Digits);
   }
   tikets = OrderSend(Symbol(),sign,lots,price,Slippage,sl,tp,komentar,magic,0,warna);
   if(tikets > 0) {
      if(OrderSelect(tikets,SELECT_BY_TICKET,MODE_TRADES)) {
         Print(komentar," tp=",OrderTakeProfit()," sl=",OrderStopLoss());
         target_sl = OrderStopLoss(); target_tp = OrderTakeProfit();
      } else Print("Error create ",komentar," Error number:",GetLastError());
      RefreshRates();
   }
return;
}

bool Available_Order() {
   bool ret = false;
   int total = OrdersTotal();
   for(int i=0; i<total; i++) {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic) {
            ret = true;
            tikets = OrderTicket();
            RefreshRates();
            break;
         }
      }
   }   
   return(ret);
}
bool BarUp(int index) { return(Open[index] < Close[index]); }
bool BarDn(int index) { return(Open[index] > Close[index]); }

double GetBB_Range(int shift) {
   return( (GetUpperBB_Value(shift) - GetLowerBB_Value(shift))/Point );
}
double GetUpperBB_Value(int shift) 
   { return(iCustom(Symbol(),0,"Bands",band_period,0,band_dev,1,shift)); }
//   { return(iBands(Symbol(),PERIOD_M15,band_period,band_dev,0,PRICE_CLOSE,MODE_UPPER,shift)); }
double GetLowerBB_Value(int shift) 
   { return(iCustom(Symbol(),0,"Bands",band_period,0,band_dev,2,shift)); }
//   { return(iBands(Symbol(),PERIOD_M15,band_period,band_dev,0,PRICE_CLOSE,MODE_LOWER,shift)); }
   
   
int GetSignal() {
int sign = -1;

double bb_atas1 = GetUpperBB_Value(1);
double bb_bawah1 = GetLowerBB_Value(1);
double bb_atas2 = GetUpperBB_Value(2);
double bb_bawah2 = GetLowerBB_Value(2);
double bb_atas3 = GetUpperBB_Value(3);
double bb_bawah3 = GetLowerBB_Value(3);
double bb_atas4 = GetUpperBB_Value(4);
double bb_bawah4 = GetLowerBB_Value(4);
double bb_atas5 = GetUpperBB_Value(5);
double bb_bawah5 = GetLowerBB_Value(5);
double rangebb = GetBB_Range(1);   // (bb_atas1 - bb_bawah1) / Point;
double batasOP = MathAbs(rangebb * BatasRangeBB_for_OP);

   if(IdleStatus) return(sign);
   if(rangebb > DailyRange * BatasMaxBB / 100 || rangebb < DailyRange * BatasMinBB / 100) return(sign);  // ini bb mengecil atau melebar, NO-OP
   if(BarDn(2) && BarDn(1) && Close[1] < bb_atas1 &&  // ini tanda-tanda awal untuk OP SELL
      ((bb_atas1 - Close[1])/Point) <= batasOP )
   {
      if(High[3] >= (bb_atas3-PipsFromBB*Point) || 
         High[4] >= (bb_atas4-PipsFromBB*Point) || 
         High[5] >= (bb_atas5-PipsFromBB*Point) )
      {
         if(Reversal) sign = OP_BUY; else sign = OP_SELL;
      }
   }
   if(BarUp(2) && BarUp(1) && Close[1] > bb_bawah1 &&  // ini tanda-tanda awal untuk OP BUY
      ((Close[1] - bb_bawah1)/Point) <= batasOP )
   {
      if(Low[3] <= (bb_bawah3+PipsFromBB*Point) || 
         Low[4] <= (bb_bawah4+PipsFromBB*Point) || 
         Low[5] <= (bb_bawah5+PipsFromBB*Point) ) 
      {
         if(Reversal) sign = OP_SELL; else sign = OP_BUY;
      }
   }
return(sign);
}
string StrType(int cmd) {
string ret;
   switch(cmd) {
      case 0: ret = " OP_BUY "; break;
      case 1: ret = " OP_SELL "; break;
      case 2: ret = " OP_BUYLIMIT "; break;
      case 3: ret = " OP_SELLLIMIT "; break;
      case 4: ret = " OP_BUYSTOP "; break;
      case 5: ret = " OP_SELLSTOP "; break;
      default: ret = ""; break;
   }
return(ret);
}
double ND(double prc) { return(NormalizeDouble(prc,Digits)); }
double ND2(double prc) { return(NormalizeDouble(prc,Digits)); }
double GetDailyAVG() {
   double ret,avg;
   int hari=JmlHariUtkDailyRange;
   double jml=0.0;
   for(int i=1; i<=hari; i++) jml = jml + (iHigh(NULL,PERIOD_D1,i) - iLow(NULL,PERIOD_D1,i))/Point;
   avg=jml/hari;
   ret = MathFloor(avg/10)*10;
   return(ret);
}
double GetLot() { 
   double ret;
   if(level_now == 0.0) ret = base_lot; else {
      ret = base_lot;
      for(int i=1; i<=level_now; i++) ret = ret * lot_multiplier;
      ret = ND2(ret);
   }
return(ret); 
}


